searchNodes=[{"doc":"Some simple HTML query functions. Delegates the hard work to Floki . Data types All functions accept HTML in the form of a string, a Floki HTML tree, or a Floki HTML node. Others expect only a Floki HTML node or a Floki HTML tree. See HtmlQuery.html/0 . Some functions take a CSS selector, which can be a string, a keyword list, or a list. See HtmlQuery.Css.selector/0 . Main query functions The main query functions take an HTML string or some parsed HTML, and a selector. all/2 return all elements matching the selector find/2 return the first element that matches the selector find!/2 return the only element that matches the selector Parsing functions parse/1 parses an HTML fragment into a [Floki HTML tree] parse_doc/1 parses an HTML doc into a [Floki HTML tree] Extraction functions attr/2 returns the attribute value as a string form_fields/1 returns the names and values of form fields as a map meta_tags/1 returns the names and values of metadata fields text/1 returns the text contents as a single string Utility functions inspect_html/2 prints prettified HTML with a label normalize/1 parses and re-stringifies HTML pretty/1 prettifies HTML Alias If you use HtmlQuery a lot, you may want to alias it to the recommended shortcut &quot;Hq&quot;: alias HtmlQuery , as : Hq Examples Get the value of a selected option: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . attr ( &quot;value&quot; ) &quot;a&quot; Get the text of a selected option, raising if there are more than one: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find! ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . text ( ) &quot;apples&quot; Get the text of all the options: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . all ( html , &quot;select option&quot; ) |&gt; Enum . map ( &amp; HtmlQuery . text / 1 ) [ &quot;apples&quot; , &quot;bananas&quot; ] Use a keyword list as the selector (see HtmlQuery.CSS for details on selectors): iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; HtmlQuery . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; HtmlQuery . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"HtmlQuery.html","title":"HtmlQuery","type":"module"},{"doc":"Finds all elements in html that match selector , returning a Floki HTML tree. iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . all ( html , &quot;option&quot; ) [ { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] } , { &quot;option&quot; , [ { &quot;value&quot; , &quot;b&quot; } ] , [ &quot;bananas&quot; ] } ]","ref":"HtmlQuery.html#all/2","title":"HtmlQuery.all/2","type":"function"},{"doc":"Returns the value of attr from the outermost element of html . If attr is an atom, any underscores are converted to dashes. iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; HtmlQuery . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; HtmlQuery . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"HtmlQuery.html#attr/2","title":"HtmlQuery.attr/2","type":"function"},{"doc":"Like find/2 but raises unless exactly one element is found.","ref":"HtmlQuery.html#find!/2","title":"HtmlQuery.find!/2","type":"function"},{"doc":"Finds the first element in html that matches selector , returning a Floki HTML node. iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find ( html , &quot;select option[selected]&quot; ) { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] }","ref":"HtmlQuery.html#find/2","title":"HtmlQuery.find/2","type":"function"},{"doc":"Returns a map containing the form fields of form selector in html . iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;color&quot; value=&quot;green&quot;&gt; &lt;textarea name=&quot;desc&quot;&gt;A tree&lt;/textarea&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ color : &quot;green&quot; , desc : &quot;A tree&quot; } If form field names are in foo[bar] format, then foo becomes a key to a nested map containing bar : iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;profile[name]&quot; value=&quot;fido&quot;&gt; &lt;input type=&quot;text&quot; name=&quot;profile[age]&quot; value=&quot;10&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ profile : %{ name : &quot;fido&quot; , age : &quot;10&quot; } }","ref":"HtmlQuery.html#form_fields/1","title":"HtmlQuery.form_fields/1","type":"function"},{"doc":"Prints prettified html with a label, and then returns the original html.","ref":"HtmlQuery.html#inspect_html/2","title":"HtmlQuery.inspect_html/2","type":"function"},{"doc":"Extracts all the meta tags from html , returning a list of maps. iex&gt; html = ~s|&lt;head&gt; &lt;meta charset=&quot;utf-8&quot;/&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot;/&gt; &lt;/head&gt;| iex&gt; HtmlQuery . meta_tags ( html ) [ %{ &quot;charset&quot; =&gt; &quot;utf-8&quot; } , %{ &quot;content&quot; =&gt; &quot;IE=edge&quot; , &quot;http-equiv&quot; =&gt; &quot;X-UA-Compatible&quot; } ]","ref":"HtmlQuery.html#meta_tags/1","title":"HtmlQuery.meta_tags/1","type":"function"},{"doc":"Parses and then re-stringifies html , increasing the liklihood that two equivalent HTML strings can be considered equal. iex&gt; a = ~s|&lt;p id=&quot;color&quot;&gt;green&lt;/p&gt;| iex&gt; b = ~s|&lt;p id = &quot;color&quot; &gt;green&lt;/p&gt;| iex&gt; a == b false iex&gt; HtmlQuery . normalize ( a ) == HtmlQuery . normalize ( b ) true","ref":"HtmlQuery.html#normalize/1","title":"HtmlQuery.normalize/1","type":"function"},{"doc":"Parses an HTML fragment using Floki.parse_fragment!/1 , returning a Floki HTML tree.","ref":"HtmlQuery.html#parse/1","title":"HtmlQuery.parse/1","type":"function"},{"doc":"Parses an HTML document using Floki.parse_document!/1 , returning a Floki HTML tree.","ref":"HtmlQuery.html#parse_doc/1","title":"HtmlQuery.parse_doc/1","type":"function"},{"doc":"Returns html as a prettified string, using Floki.raw_html/2 and its pretty: true option.","ref":"HtmlQuery.html#pretty/1","title":"HtmlQuery.pretty/1","type":"function"},{"doc":"Returns the text value of html . iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find! ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . text ( ) &quot;apples&quot;","ref":"HtmlQuery.html#text/1","title":"HtmlQuery.text/1","type":"function"},{"doc":"A string or atom representing an attribute name. If an atom, underscores are converted to dashes.","ref":"HtmlQuery.html#t:attr/0","title":"HtmlQuery.attr/0","type":"type"},{"doc":"A string, a struct that implements the String.Chars protocol, a Floki HTML tree , or a Floki HTML node .","ref":"HtmlQuery.html#t:html/0","title":"HtmlQuery.html/0","type":"type"},{"doc":"Constructs CSS selectors via Elixir data structures. See selector/1 for details.","ref":"HtmlQuery.Css.html","title":"HtmlQuery.Css","type":"module"},{"doc":"Accepts a string, atom, keyword list, or list, and returns a CSS string. String syntax When given a string, returns the string. This is useful when you don't know if a selector is already a string. iex&gt; HtmlQuery.Css . selector ( &quot;.profile[test-role=&#39;new-members&#39;]&quot; ) &quot;.profile[test-role=&#39;new-members&#39;]&quot; Atom syntax When given an atom, converts the atom to a string, without converting underscores to dashes. iex&gt; HtmlQuery.Css . selector ( :p ) &quot;p&quot; Keyword list syntax The keyword list syntax is intentionally limited; complex selectors are more easily written as strings. The keyword list syntax makes it a bit eaiser to write simple selectors or selectors that use variables: e.g.: HtmlQuery.Css . selector ( test_role : &quot;new-members&quot; ) HtmlQuery.Css . selector ( id : some_variable ) Keys are expected to be atoms and will be dasherized ( foo_bar -&gt; foo-bar ). Values are expected to be strings or another keyword list. A key/value pair will be converted to an attribute selector: iex&gt; HtmlQuery.Css . selector ( test_role : &quot;new-members&quot; ) &quot;[test-role=&#39;new-members&#39;]&quot; A keyword list will be converted to a list of attribute selectors: iex&gt; HtmlQuery.Css . selector ( class : &quot;profile&quot; , test_role : &quot;new-members&quot; ) &quot;[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; (Note that the CSS selector .profile expands to [class~='profile'] which is not equivalent to [class='profile'] . The keyword list syntax will not generate ~= selectors so you should use a string selector such as &quot;.profile[test-role='new-members']&quot; instead if you want ~= semantics. See the CSS spec for details.) When the value is a keyword list, the key is converted to an element selector: iex&gt; HtmlQuery.Css . selector ( p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; List syntax The list syntax is intentionally limited; complex selectors are more easily written as strings. When the value is a list (vs a keyword list), atoms are converted to element selectors and keyword lists are converted as described above. iex&gt; HtmlQuery.Css . selector ( [ [ p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ] , :div , [ class : &quot;tag&quot; ] ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;] div [class=&#39;tag&#39;]&quot;","ref":"HtmlQuery.Css.html#selector/1","title":"HtmlQuery.Css.selector/1","type":"function"},{"doc":"See docs for selector/1 for more details.","ref":"HtmlQuery.Css.html#t:selector/0","title":"HtmlQuery.Css.selector/0","type":"type"},{"doc":"An exception raised when unable to find an HTML element.","ref":"HtmlQuery.QueryError.html","title":"HtmlQuery.QueryError","type":"exception"},{"doc":"Some simple HTML query functions. Delegates the hard work to Floki . iex&gt; alias HtmlQuery , as : Hq iex&gt; html = &quot;&quot;&quot; &lt;form id=&quot;profile&quot; test-role=&quot;profile&quot;&gt; &lt;label&gt;Name &lt;input name=&quot;name&quot; type=&quot;text&quot; value=&quot;Fido&quot;&gt; &lt;/label&gt; &lt;label&gt;Age &lt;input name=&quot;age&quot; type=&quot;text&quot; value=&quot;10&quot;&gt; &lt;/label&gt; &lt;label&gt;Bio &lt;textarea name=&quot;bio&quot;&gt;Fido likes long walks and playing fetch.&lt;/textarea&gt; &lt;/label&gt; &lt;/form&gt; &lt;/form&gt; &quot;&quot;&quot; iex&gt; html |&gt; Hq . find! ( test_role : &quot;profile&quot; ) { &quot;form&quot; , [ { &quot;id&quot; , &quot;profile&quot; } , { &quot;test-role&quot; , &quot;profile&quot; } ] , [ { &quot;label&quot; , [ ] , [ &quot;Name &quot; , { &quot;input&quot; , [ { &quot;name&quot; , &quot;name&quot; } , { &quot;type&quot; , &quot;text&quot; } , { &quot;value&quot; , &quot;Fido&quot; } ] , [ ] } ] } , { &quot;label&quot; , [ ] , [ &quot;Age &quot; , { &quot;input&quot; , [ { &quot;name&quot; , &quot;age&quot; } , { &quot;type&quot; , &quot;text&quot; } , { &quot;value&quot; , &quot;10&quot; } ] , [ ] } ] } , { &quot;label&quot; , [ ] , [ &quot;Bio &quot; , { &quot;textarea&quot; , [ { &quot;name&quot; , &quot;bio&quot; } ] , [ &quot;Fido likes long walks and playing fetch.&quot; ] } ] } ] } iex&gt; html |&gt; Hq . all ( &quot;input[type=text]&quot; ) |&gt; Enum . map ( &amp; Hq . attr ( &amp;1 , &quot;value&quot; ) ) [ &quot;Fido&quot; , &quot;10&quot; ] iex&gt; html |&gt; Hq . find ( test_role : &quot;profile&quot; ) |&gt; Hq . form_fields ( ) %{ age : &quot;10&quot; , bio : &quot;Fido likes long walks and playing fetch.&quot; , name : &quot;Fido&quot; }","ref":"readme.html","title":"HtmlQuery","type":"extras"},{"doc":"https://hexdocs.pm/html_query/HtmlQuery.html","ref":"readme.html#api-docs","title":"HtmlQuery - API Docs","type":"extras"},{"doc":"def deps do [ { :html_query , &quot;~&gt; 0.2&quot; } ] end","ref":"readme.html#installation","title":"HtmlQuery - Installation","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]